function common.serverList(window)
	if window then
		window:clear()
		window:insert("Fetching server list...")
		
		fetch_server_list(function(list)
			window:clear()
			if list then
				for _, server in ipairs (list) do
					local n = window:insert(server.title, server.mod, server.map)
					n:data().ip = server.ip
				end
			else
				window:insert("Couldn't fetch list from server")
			end
		end)
	end
end

function common.initChat()
	if not DEDSERV then
		gui_load_gss("chat")
		local chatboxw = gui_load_xml("chat")
		
		chatboxw:set_visibility(false)
			
		function chatboxw:onKeyDown(k)
			if k == Keys.ESC then
				self:set_visibility(false)
				return true
			end
		end
		
		local chattextw = chatboxw:child("chattext")
		
		function chattextw:onAction()
			local p = game_local_player(0)
			if p then
				p:say(self:text())
				chatboxw:set_visibility(false)
			end
		end
		
		console_register_command("SHOWCHAT", function()
			if game_local_player(0) and not mainm.isShown() then
				chatboxw:set_visibility(true)
				local w = chatboxw:child("chattext")
				w:set_text("")
				w:focus()
				w:activate()
				clear_keybuf()
			end
		end)
	end
end

function common.initHUD(options)

	if not DEDSERV then
		options = options or {} 

		local testCrosshair = sprites_load("crosshair")
		local killsMeter = sprites_load("kills")
		local life = sprites_load("life")
		local ammo = sprites_load("ammo")
		local kraftammo = sprites_load("kraftammo")
		local skinyperit = sprites_load("yperit")
	

		local hudFont = fonts.liero

		function bindings.wormRender(x, y, worm, viewport, ownerPlayer)

			local ownViewport = ( ownerPlayer == worm:player() )

			local bitmap = viewport:bitmap()

			if not ownViewport then
				if not options.hideEnemyHealth then
					gfx_set_alpha(90)
					bitmap:draw_box(x - 6, y - 17, x + 6, y - 16, color(255, 255, 255))
					gfx_reset_blending()
					local filled = (worm:health() / 100)
					bitmap:draw_box(x - 6, y - 17, x - 6 + filled * 12, y - 16, hudtools.greenRedInterpol(1-filled))
				end
				
				if not options.hideNames then
					fonts.minifont:render( bitmap, worm:player():name(), x, y - 10, color(255, 255, 255), Font.Formatting + Font.CenterH + Font.CenterV )
				end
				
			else

---GAS THINGIES---
		if worm:player():data().gasmeter > 0 and worm:player():data().gasmeter <= 250 and gameover == 0 then
			local gaseffect = sprites_load("gaseffect")
			local gaseffect2 = sprites_load("gaseffect2")
			local gasmeter = worm:player():data().gasmeter

			gfx_set_add(((gasmeter-100)/150)*255)
			gaseffect2:render(bitmap, 0, 160, 120)
			gfx_reset_blending()
			gfx_set_alphach(((gasmeter-100)/150)*255)
			gaseffect:render(bitmap, 0, 160, 120)
			gfx_reset_blending()
			end

		if worm:player():data().gasmeter > 250 and worm:player():data().gasmeter <= 255 and gameover == 0 then
			local gaseffect = sprites_load("gaseffect")
			local gaseffect2 = sprites_load("gaseffect2")
			local gasmeter = worm:player():data().gasmeter

			gfx_set_add(255)
			gaseffect2:render(bitmap, 0, 160, 120)
			gfx_reset_blending()
			gfx_set_alphach(255)
			gaseffect:render(bitmap, 0, 160, 120)
			gfx_reset_blending()
			end

			gfx_reset_blending()

			if worm:player():data().yperitpress == 1
			then hudFont:render( bitmap, "Too much gas on the map!", bitmap:w()/2, 30, color(255, 0, 0), Font.Shadow + Font.CenterH )
			end
	

				if worm:player():data().gasmeter <= 100 then
				local dx, dy = angle_vector(worm:angle(), 25)
				testCrosshair:render(bitmap, 0, x + dx, y + dy)
				else
				local gasmeter = worm:player():data().gasmeter
				local dx, dy = angle_vector(worm:angle(), 25)
				gfx_set_alpha(255-(((gasmeter-100)/155)*255))
				testCrosshair:render(bitmap, 0, x + dx, y + dy)
				end
			end
						
			--fonts.minifont:render( bitmap, worm:get_player():team(), x, y - 30, 0, 255, 0, Font.CenterH )
		end
		
		function bindings.viewportRender(viewport, worm)
			local bitmap = viewport:bitmap()
			local filled = (worm:health() / 100)
			local limit = 200-filled*2

---PROPER HUD---

			killsMeter:render(bitmap, 0, bitmap:w()-16, 14)
			
			
			local frags = (worm:player():kills() - worm:player():data().suicides)
			
			if frags > 9 and fraglimit >= 20 then
			fonts.minifont:render(bitmap, frags.."/"..fraglimit, bitmap:w()-41, 12, color(155, 155, 155), 0)
			end

			if frags <= 9 and frags >= 0 and fraglimit >= 20 then 
			fonts.minifont:render(bitmap, frags.."/"..fraglimit, bitmap:w()-37, 12, color(155, 155, 155), 0)
			end

			if frags < 0 and fraglimit >= 20 then 
			fonts.minifont:render(bitmap, frags.."/"..fraglimit, bitmap:w()-41, 12, color(155, 155, 155), 0)
			end

			if frags > 9 and fraglimit <= 9 then
			fonts.minifont:render(bitmap, frags.."/"..fraglimit, bitmap:w()-37, 12, color(155, 155, 155), 0)
			end

			if frags <= 9 and frags >= 0 and fraglimit <= 9 then
			fonts.minifont:render(bitmap, frags.."/"..fraglimit, bitmap:w()-33, 12, color(155, 155, 155), 0)
			end

			if frags < 0 and fraglimit <= 9 then
			fonts.minifont:render(bitmap, frags.."/"..fraglimit, bitmap:w()-37, 12, color(155, 155, 155), 0)
			end

			if frags > 9 and fraglimit > 9 and fraglimit < 20 then
			fonts.minifont:render(bitmap, frags.."/", bitmap:w()-39, 12, color(155, 155, 155), 0)
			fonts.minifont:render(bitmap, fraglimit, bitmap:w()-29, 12, color(155, 155, 155), 0)
			end

			if frags <= 9 and frags >= 0 and fraglimit > 9 and fraglimit < 20 then
			fonts.minifont:render(bitmap, frags.."/", bitmap:w()-35, 12, color(155, 155, 155), 0)
			fonts.minifont:render(bitmap, fraglimit, bitmap:w()-29, 12, color(155, 155, 155), 0)
			end

			if frags < 0 and fraglimit > 9 and fraglimit < 20 then
			fonts.minifont:render(bitmap, frags.."/", bitmap:w()-39, 12, color(155, 155, 155), 0)
			fonts.minifont:render(bitmap, fraglimit, bitmap:w()-29, 12, color(155, 155, 155), 0)
			end

			if filled <= 0 and gameover == 0 and worm:player() == game_local_player(0) then
			local wtf = console["+P0_jump"]
			local wtf = console["-P0_change"]
			local wtf = console["-P0_down"]
			local wtf = console["-P0_up"]
			local wtf = console["-P0_left"]
			local wtf = console["-P0_right"]
			end
			if filled <= 0 and gameover == 0 and worm:player() == game_local_player(1) then
			local wtf = console["+P1_jump"]
			local wtf = console["-P1_change"]
			local wtf = console["-P1_down"]
			local wtf = console["-P1_up"]
			local wtf = console["-P1_left"]
			local wtf = console["-P1_right"]
			end

			bitmap:draw_box(bitmap:w()-10, 5, bitmap:w()-7, 33, color(105, 105, 105))
			bitmap:draw_box(bitmap:w()-64, 5, bitmap:w()-14, 8, color(105, 105, 105))

			life:render(bitmap, 0, bitmap:w()-16, 22)

			if worm:health() == 100 then
			fonts.minifont:render(bitmap, floor(worm:health()), bitmap:w()-33, 20, color(155, 155, 155), 0)
			end

			if worm:health() > 9 and worm:health() < 100 then
			fonts.minifont:render(bitmap, floor(worm:health()), bitmap:w()-29, 20, color(155, 155, 155), 0)
			end

			if worm:health() <= 9 then
			fonts.minifont:render(bitmap, floor(worm:health()), bitmap:w()-25, 20, color(155, 155, 155), 0)
			end
			
			hudtools.drawHBar( bitmap, filled, bitmap:w()-63, 6, 48, 1)

---SUICIDE MESSAGE---

			if worm:player():data().msgcounter > 0 and worm:player():data().msgcounter < 155 and gameover == 0 then
			 hudFont:render(bitmap, "You killed yourself!", bitmap:w()/2, 180, color(200, 0, 0), Font.Shadow + Font.CenterH)
			 hudFont:render(bitmap, "Frags   -1", bitmap:w()/2, 190, color(200, 0, 0), Font.Shadow + Font.CenterH)
			end

			gfx_set_alpha(255 - (worm:player():data().msgcounter-155)*2.55)
			if worm:player():data().msgcounter >= 155 and gameover == 0 then
			 hudFont:render(bitmap, "You killed yourself!", bitmap:w()/2, 180, color(200, 0, 0), Font.Shadow + Font.CenterH)
			 hudFont:render(bitmap, "Frags   -1", bitmap:w()/2, 190, color(200, 0, 0), Font.Shadow + Font.CenterH)
			gfx_reset_blending()
			end


---FRAGGED MESSAGE---

			if worm:player():data().msgcounter2 > 0 and worm:player():data().msgcounter2 < 155 and gameover ==0 then
			 hudFont:render(bitmap, "You Fragged "..worm:player():data().whofragged.."!", bitmap:w()/2, 150, color(0, 200, 0), Font.Shadow + Font.CenterH)
			 hudFont:render(bitmap, "Frags   +1", bitmap:w()/2, 160, color(0, 200, 0), Font.Shadow + Font.CenterH)
			end

			gfx_set_alpha(255 - (worm:player():data().msgcounter2-155)*2.55)
			if worm:player():data().msgcounter2 >= 155 and gameover == 0 then
			 hudFont:render(bitmap, "You Fragged "..worm:player():data().whofragged.."!", bitmap:w()/2, 150, color(0, 200, 0), Font.Shadow + Font.CenterH)
			 hudFont:render(bitmap, "Frags   +1", bitmap:w()/2, 160, color(0, 200, 0), Font.Shadow + Font.CenterH)
			gfx_reset_blending()
			end




			local w = worm:current_weapon()
			gfx_reset_blending()

---WEAPON NAME RENDER/---

if w:type():name() == "Yperit" or w:type():name() == "Kar98k" then
fonts.minifont:render(bitmap, w:type():name(), bitmap:w()-30, 35, color(200, 200, 200), 0)
elseif w:type():name() == "Railwaffe" or w:type():name() == "Die Kraft" then
fonts.minifont:render(bitmap, w:type():name(), bitmap:w()-42, 35, color(200, 200, 200), 0)
elseif w:type():name() == "Panzerschreck" or w:type():name() == "Flammenwerfer" then
fonts.minifont:render(bitmap, w:type():name(), bitmap:w()-58, 35, color(200, 200, 200), 0)
elseif w:type():name() == "Nagelkarabiner" then
fonts.minifont:render(bitmap, w:type():name(), bitmap:w()-62, 35, color(200, 200, 200), 0)
elseif w:type():name() == "MP 40" then
fonts.minifont:render(bitmap, w:type():name(), bitmap:w()-26, 35, color(200, 200, 200), 0)
elseif w:type():name() == "Teslakanone" then
fonts.minifont:render(bitmap, w:type():name(), bitmap:w()-50, 35, color(200, 200, 200), 0)
end

---/WEAPON NAME RENDER---

			if w:type():name() == "Yperit" then

			   ammo:render(bitmap, 0, bitmap:w()-16, 30)

			   fonts.minifont:render(bitmap, floor(worm:player():data().yperitammo), bitmap:w()-25, 28, color(155, 155, 155), 0)
			   filled = worm:player():data().yperitammo
			   hudtools.drawVBar( bitmap, filled, bitmap:w()-8, 32, 1, 26 )

			 
			elseif w:type():name() == "Die Kraft" then
			   
			   kraftammo:render(bitmap, 0, bitmap:w()-16, 30)
			   filled = worm:player():data().kraftmana / 100
			   hudtools.drawVBlue( bitmap, filled, bitmap:w()-8, 32, 1, 26 )  

			elseif w:type():name() == "Flammenwerfer" then

			   fonts.minifont:render(bitmap, "Mad-o-meter", bitmap:w()-59, 28, color(155, 155, 155), 0)
			   filled = worm:player():data().madcount / 100
			   hudtools.madBar( bitmap, filled, bitmap:w()-8, 32, 1, 26 )
	   	   	   	   if worm:player():data().ismad == 1 and worm:player():data().timer > 15
	   	   	   	   then hudFont:render( bitmap, "FEUER FRENZY", bitmap:w()/2, 30, color(255, 0, 0), Font.Shadow + Font.CenterH )
	   	   	   	   end

 
			else

			  ammo:render(bitmap, 0, bitmap:w()-16, 30)

			  if w:ammo() > 9 then
			  fonts.minifont:render(bitmap, w:ammo(), bitmap:w()-29, 28, color(155, 155, 155), 0)
			  end

			  if w:ammo() <= 9 then
			  fonts.minifont:render(bitmap, w:ammo(), bitmap:w()-25, 28, color(155, 155, 155), 0)
			  end

			  if w:is_reloading() then
				filled = 1 - w:reload_time() / w:type():reload_time()
			  else
				filled = w:ammo() / w:type():ammo()
			  end
			  hudtools.drawVBar( bitmap, filled, bitmap:w()-8, 32, 1, 26 )
			
			end
			
			if gameover == 1 then
			  if worm:player():name() == winnername then fonts.big:render( bitmap, "You have won the match!", bitmap:w()/2, 200, color(255, 255, 255), Font.Shadow + Font.CenterH )
			  else fonts.big:render( bitmap, winnername.." has won the match!", bitmap:w()/2, 200, color(255, 255, 255), Font.Shadow + Font.CenterH )
			end
			end

		end


	end
end





function common.initWeaponSelection()
	if not DEDSERV then
		local maxSelectableWeapons = 2
		local selectWeaponStart = maxSelectableWeapons+1
		local selectWeaponCount = selectWeaponStart+1
		
		function bindings.viewportRender(viewport, worm)
			local bitmap = viewport:bitmap()
			local player = worm:player()
			if player and player:data().weaponSelection and gameover == 0 then
				worm:player():data().scoreboardVisible = true
				local o = player:data().weaponSelection
				local y = 48
				local x = 15
				local i = 0

				if AUTH and player:data().started == 0 then
				gfx_set_alpha(100)
				bitmap:draw_box(10, 43, 105, 119, color(0, 0, 0))
				gfx_reset_blending()

				bitmap:line(9, 42, 106, 42, color(155,155,155))
				bitmap:line(9, 119, 106, 119, color(155,155,155))
				bitmap:line(9, 43, 9, 119, color(155,155,155))
				bitmap:line(106, 43, 106, 119, color(155,155,155))
				bitmap:line(9, 57, 106, 57, color(155,155,155))
				bitmap:line(9, 93, 106, 93, color(155,155,155))
				else
				gfx_set_alpha(100)
				bitmap:draw_box(10, 43, 105, 93, color(0, 0, 0))
				gfx_reset_blending()

				bitmap:line(9, 42, 106, 42, color(155,155,155))
				bitmap:line(9, 93, 106, 93, color(155,155,155))
				bitmap:line(9, 43, 9, 93, color(155,155,155))
				bitmap:line(106, 43, 106, 93, color(155,155,155))
				bitmap:line(9, 57, 106, 57, color(155,155,155))
				end
				
				local function drawRow(name)
					if i == o.cur then
						fonts.liero:render(
							bitmap,
							name,
							x, y,
							color(50, 190, 50), Font.Shadow)
					else
						fonts.liero:render(
							bitmap,
							name,
							x, y,
							color(255, 255, 255), Font.Shadow)
					end
					y = y + 11
					i = i + 1
				end

				drawRow("Randomize Waffen")
				x = 45

				y = 62

				local Kar98k = sprites_load("menkar")
				local yperit = sprites_load("menyperit")
				local mp40 = sprites_load("menmp")
				local rail = sprites_load("menrail")
				local nagel = sprites_load("mennagel")
				local tesla = sprites_load("mentesla")
				local kraft = sprites_load("menkraft")
				local panzer = sprites_load("menpanzer")
				local flam = sprites_load("menflam")
				
					drawRow(o.list[1]:name())
					if o.list[1]:name() == "Kar98k" then Kar98k:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Yperit" then yperit:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "MP 40" then mp40:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Railwaffe" then rail:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Nagelkarabiner" then nagel:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Teslakanone" then tesla:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Panzerschreck" then panzer:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Flammenwerfer" then flam:render(bitmap, 0, x-30, y-7)
					elseif o.list[1]:name() == "Die Kraft" then 
gfx_set_add(255) 
kraft:render(bitmap, 0, x-30, y-7)
gfx_reset_blending()
					end

					drawRow(o.list[2]:name())
					if o.list[2]:name() == "Kar98k" then Kar98k:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Yperit" then yperit:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "MP 40" then mp40:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Railwaffe" then rail:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Nagelkarabiner" then nagel:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Teslakanone" then tesla:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Panzerschreck" then panzer:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Flammenwerfer" then flam:render(bitmap, 0, x-30, y-7)
					elseif o.list[2]:name() == "Die Kraft" then 
gfx_set_add(255) 
kraft:render(bitmap, 0, x-30, y-7)
gfx_reset_blending()
					end

				x = 15
				drawRow("Spawn!")

				if AUTH and player:data().started == 0 then

				selectWeaponCount = 5
				y = 109
				drawRow(fraglimit)

				y = 99
				drawRow("Frag Limit:")

				end

				if player:data().started == 1 then
				selectWeaponCount = 4
				end
			end
		end
		
		local function randomWeapons()
			local list = {}
			
			for i = 1, 2 do
				local ok
				
				repeat
					list[i] = weapon_random()
					
					if weapon_count() < maxSelectableWeapons then
						break
					end
					
					ok = true
					for j = 1, i-1 do
						if list[j] == list[i] then
							ok = false
						end
					end
				until ok
			end
			
			return list
		end
		
		function bindings.localplayerEvent(player, event, state)
			local o = player:data().weaponSelection
			if o then
				if state then
					if event == Player.Down then
						o.cur = o.cur + 1
						if o.cur >= selectWeaponCount then
							o.cur = 0
						end
					elseif event == Player.Up then
						o.cur = o.cur - 1
						if o.cur < 0 then
							o.cur = selectWeaponCount - 1
						end
					elseif event == Player.Fire then
						o.pressed = true
					elseif o.list[o.cur] then
						if event == Player.Left then
							o.list[o.cur] = o.list[o.cur]:prev()

					for wpn = 1,2 do
					if o.list[o.cur]:name() == o.list[wpn]:name() and o.cur ~= wpn then							o.list[o.cur] = o.list[o.cur]:prev()						
					end
					end

						elseif event == Player.Right then
							o.list[o.cur] = o.list[o.cur]:next()

					for wpn = 1,2 do
					if o.list[o.cur]:name() == o.list[wpn]:name() and o.cur ~= wpn then							o.list[o.cur] = o.list[o.cur]:next()						
					end
					end

						end
					end
				else
					if event == Player.Fire then
						o.pressed = false
					end
				end
						

					if AUTH and player:data().started == 0 and o.cur == 4 then
						if event == Player.Left and fraglimit > 0 and state then
							fraglimit = fraglimit -1
						elseif event == Player.Right and state then
							fraglimit = fraglimit +1
						end
					end
		
				
				return true -- Swallow all events if we're in weapon selection
			end
		end
		
		function bindings.playerUpdate(player)
			local o = player:data().weaponSelection
			if o and o.pressed then
				if o.cur == 0 then
					o.list = randomWeapons()
				elseif o.cur == selectWeaponStart then
					player:select_weapons(o.list)
					player:data().weaponSelection = nil
					player:data().started = 1
					player:data().weps = o.list
					player:data().scoreboardVisible = false

				else
					local ok
					repeat
						o.list[o.cur] = weapon_random()
						
						if weapon_count() < maxSelectableWeapons then
							break
						end
						
						ok = true
						for j = 1, maxSelectableWeapons do
							if j ~= o.cur and o.list[j] == o.list[o.cur] then
								ok = false
							end
						end
					until ok
				end
			end
		end
		
		function bindings.localplayerInit(player)
			player:data().weaponSelection =
			{
				list = randomWeapons(),
				cur = 1
			}
			player:data().started = 0
		end

		function bindings.wormDeath(worm)
			local weps = worm:player():data().weps
			worm:player():data().weaponSelection =
			{
				list = weps,
				cur = 3
			} 
		end
	
	end
end

function common.init(options)
	common.initHUD(options)
	common.initChat(options)
	common.initWeaponSelection(options)
	
	console_register_command("SHOWMENU", function()
		mainm.show()
	end)

	if not DEDSERV then
		mainm.init()
	end

end       