function weapons.init()
 local nail = load_particle("nail.obj")
 local kraft = load_particle("kraft.obj")
 local rocket = load_particle("rocket.obj")
 local rail = load_particle("rail.obj")
 local yperit = load_particle("yperit.obj")
 local tesla = load_particle("shock.obj")
 local kar = load_particle("kar.obj")
 local bouncesound = load_particle("bouncesound.obj")
 local shellsound3 = load_particle("shellsound3.obj")
 local shellsound2 = load_particle("shellsound2.obj")
 local shellsound = load_particle("shellsound.obj")
 local shell = load_particle("shell.obj")
 local shell2 = load_particle("shell2.obj")
 local flameobj = load_particle("flamestart.obj")

 local n2fix = function( num, prec )
 return math.floor( num * (2^prec) )
 end

 local f2num = function( fix, prec )
 return fix / ( 2^prec )
 end

 local function putObject( object, objtype, x, y, xspd, yspd )
 local ix, iy = object:pos()
 local ixspd, iyspd = object:spd()
		
 object:set_pos( x, y )
 object:set_spd( xspd, yspd )
		
 object:shoot(objtype, 1, 0, 0, 1 )
		
 object:set_pos( ix, iy )
 object:set_spd( ixspd, iyspd )
 end

 

 local function shootWeapon( worm, x, y, xspd, yspd, type ) -- x and y are fixed point with 8 bit precision, xspd and yspd are fixed point with 16 bit precision!
		if type == "nagel" then
			putObject( worm, nail, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
		if type == "kraft" then
			putObject( worm, kraft, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
		if type == "kar" then
			putObject( worm, kar, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
		if type == "rocket" then
			putObject( worm, rocket, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
		if type == "rail" then
			putObject( worm, rail, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
		if type == "tesla" then
			putObject( worm, tesla, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
		if type == "yperit" then
			putObject( worm, yperit, f2num(x, 8), f2num(y, 8), f2num(xspd,16), f2num(yspd, 16) )
		end
	end

local nailShootEvent = network_worm_event( "nailshot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "nagel" ) 
		end
	)

local kraftShootEvent = network_worm_event( "kraftshot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "kraft" ) 
		end
	)

local rocketShootEvent = network_worm_event( "rocketshot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "rocket" ) 
		end
	)

local railShootEvent = network_worm_event( "railshot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "rail" ) 
		end
	)

local teslaShootEvent = network_worm_event( "teslashot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "tesla" ) 
		end
	)

local yperitShootEvent = network_worm_event( "yperitshot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "yperit" ) 
		end
	)

local karShootEvent = network_worm_event( "karshot", 
		function(event, worm, data)
			local x = data:get_int()
			local y = data:get_int()
			local vx = data:get_int()
			local vy = data:get_int()
			shootWeapon( worm, x, y, vx, vy, "kar" ) 
		end
	)

function weapons.nailshot(worm)
if AUTH then
 local wx, wy = worm:pos()
 local wvx, wvy = worm:spd()
 local ang = worm:angle()
 local vx, vy = angle_vector( ang, 1.4 )
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "nagel" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
nailShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end
end

kraftmsg = network_player_event("kraftmsg", function(self, player, data) weapons.kraftshot(player) end)

function weapons.kraftshot(player)
 local wx, wy = player:worm():pos()
 local wvx, wvy = player:worm():spd()
 local ang = player:worm():angle()
 local vx, vy = angle_vector( ang, 1.5 )
 local worm = player:worm()
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "kraft" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
kraftShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end

function weapons.karshot(worm)
worm:player():data().karshot = 1
if AUTH then
 local wx, wy = worm:pos()
 local wvx, wvy = worm:spd()
 local ang = worm:angle()
 local vx, vy = angle_vector( ang, 0.8 )
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "kar" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
karShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end
end

function weapons.rocketshot(worm)
if AUTH then
 local wx, wy = worm:pos()
 local wvx, wvy = worm:spd()
 local ang = worm:angle()
 local vx, vy = angle_vector( ang, 1.2 )
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "rocket" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
rocketShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end
end

function weapons.railgunshot(worm)
worm:player():data().railshot = 1
if AUTH then
 local wx, wy = worm:pos()
 local wvx, wvy = worm:spd()
 local ang = worm:angle()
 local vx, vy = angle_vector( ang, 1 )
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "rail" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
railShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end
end

function weapons.teslashot(worm)
if AUTH then
 local wx, wy = worm:pos()
 local wvx, wvy = worm:spd()
 local ang = worm:angle()
 local vx, vy = angle_vector( ang, 2 )
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "tesla" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
teslaShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end
end

function weapons.yperitshot(worm)
if AUTH then
 local wx, wy = worm:pos()
 local wvx, wvy = worm:spd()
 local ang = worm:angle()
 local vx, vy = angle_vector( ang, 2.5 )

 local MotionInheritance = 0.6
 vx = vx + MotionInheritance * wvx
 vy = vy + MotionInheritance * wvy
			
 local fx, fy, fvx, fvy = n2fix( wx, 8 ), n2fix(wy, 8), n2fix(vx, 16), n2fix(vy, 16)
 shootWeapon( worm, fx, fy, fvx, fvy, "yperit" )
			
local b = new_bitstream()
b:add_int(fx)
b:add_int(fy)
b:add_int(fvx)
b:add_int(fvy)
yperitShootEvent:send( worm, b, 0, SendMode.ReliableUnordered, RepRule.Auth2All )
end
end

function weapons.kraftshooting(player)
if player:worm():current_weapon():type():name() == "Die Kraft" 
and player:data().kraftpress == 1 and player:data().kraftmana >= 40 then
  local b = new_bitstream()
  kraftmsg:send(player, b, 0, SendMode.ReliableOrdered, RepRule.Owner2Auth )
 if AUTH then
  weapons.kraftshot(player)
 end
local sound = sounds["kraft.ogg"]
local x,y = player:worm():pos()
sound:play(x, y, 100, 1, 0)
player:data().kraftmana = player:data().kraftmana - 40
end
end

function weapons.aciddamage(object, worm)
worm:damage( 100, worm:player() )
weapons.hit(worm, worm)
end

function weapons.kraftdamage(object, worm)
worm:damage( 70, object:player() )
weapons.hit(object, worm)
end

function weapons.raildamage(object, worm)
worm:damage( 10, object:player() )
weapons.hit(object, worm)
end

function weapons.rocketdamage1(object, worm)
worm:damage( 20, object:player() )
weapons.hit(object, worm)
end

function weapons.rocketdamage2(object, worm)
worm:damage( 20, object:player() )
weapons.hit(object, worm)
end

function weapons.rocketdamage3(object, worm)
worm:damage( 40, object:player() )
weapons.hit(object, worm)
end

function weapons.rocketdamage4(object, worm)
worm:damage( 100, object:player() )
weapons.hit(object, worm)
end

function weapons.flamedamage(object, worm)
worm:damage( 0.02, object:player() )
weapons.hit(object, worm)
end

function weapons.naildamage(object, worm)
worm:damage( 25, object:player() )
weapons.hit(object, worm)
end

function weapons.mpdamage(object, worm)
worm:damage( 8, object:player() )
weapons.hit(object, worm)
end

function weapons.kardamage(object, worm)
worm:damage( 40, object:player() )
weapons.hit(object, worm)
end

function weapons.shockdamage(object, worm)
worm:damage( 10, object:player() )
weapons.hit(object, worm)
end

function weapons.shockdamage2(object, worm)
worm:damage( 1, object:player() )
weapons.hit(object, worm)
end

function weapons.shell(object)
 if vector_distance( object:spd() ) > 0.1 then
 object:shoot(shellsound, 1)
end
end

function weapons.shell2(object)
 if vector_distance( object:spd() ) > 0.1 then
 object:shoot(shellsound2, 1)
end
end

function weapons.shell3(object)
 if vector_distance( object:spd() ) > 0.2 then
 object:shoot(shellsound3, 1)
end
end

function weapons.grenade(object)
 if vector_distance( object:spd() ) > 0.2 then
 object:shoot(bouncesound, 1)
end
end

function weapons.shelleject(worm)
 if worm:player():data().shell < 120
 and worm:player():data().railshot == 1
 then worm:player():data().shell = worm:player():data().shell + 1
end
 if worm:player():data().shell == 120
 and worm:player():data().railshot == 1
 then
 worm:player():data().shell = 0
 worm:player():data().railshot = 0
 worm:shoot(shell, 1 , 1, 0.3, 0.5, 0, 20, -135)
end
end

function weapons.shelleject2(worm)
 if worm:player():data().shell2 < 90
 and worm:player():data().karshot == 1
 then worm:player():data().shell2 = worm:player():data().shell2 + 1
end
 if worm:player():data().shell2 == 90
 and worm:player():data().karshot == 1
 then
 worm:player():data().shell2 = 0
 worm:player():data().karshot = 0
 worm:shoot(shell2, 1 , 0.5, 0.3, 0.5, 0, 20, -135)
end
end

---LAUGH---

function weapons.madcount(worm)
if worm:player():data().ismad == 0 then

worm:shoot(flameobj, 2, 0.5, 0.2, 0, 0, 5, 0, 6)
if worm:player():data().flamesound == 3 then
 local sound = sounds["flame.ogg"]
 local x,y = worm:pos()
 sound:play(x, y, 35, 1, 0.4)
 worm:player():data().flamesound = 0
else worm:player():data().flamesound = worm:player():data().flamesound + 1
end

if worm:player():data().madcount < 100 then
worm:player():data().madcount = worm:player():data().madcount + 0.35
end

if worm:player():data().madcount > 40 and worm:player():data().madcount < 40.25 then
random = randomint(1, 4)
local x,y = worm:pos()
 if random == 1 then
 local sound = sounds["laugh1-1.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 2 then
 local sound = sounds["laugh1-2.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 3 then
 local sound = sounds["laugh1-3.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 4 then
 local sound = sounds["laugh1-4.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
end
if worm:player():data().madcount > 60 and worm:player():data().madcount < 60.25 then
random = randomint(1, 6)
 local x,y = worm:pos()
 if random == 1 then
 local sound = sounds["laugh2-1.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 2 then
 local sound = sounds["laugh2-2.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 3 then
 local sound = sounds["laugh2-3.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 4 then
 local sound = sounds["laugh2-4.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 5 then
 local sound = sounds["laugh2-5.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 6 then
 local sound = sounds["laugh2-6.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
end
if worm:player():data().madcount > 80 and worm:player():data().madcount < 80.25 then
random = randomint(1, 6)
local x,y = worm:pos()
 if random == 1 then
 local sound = sounds["laugh2-1.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 2 then
 local sound = sounds["laugh2-2.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 3 then
 local sound = sounds["laugh2-3.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 4 then
 local sound = sounds["laugh2-4.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 5 then
 local sound = sounds["laugh2-5.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 6 then
 local sound = sounds["laugh2-6.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
end
if worm:player():data().madcount > 99 and worm:player():data().madcount < 99.25 then
random = randomint(1, 7)
local x,y = worm:pos()
 if random == 1 then
 local sound = sounds["laugh3-1.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 2 then
 local sound = sounds["laugh3-2.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 3 then
 local sound = sounds["laugh3-3.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 4 then
 local sound = sounds["laugh3-4.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 5 then
 local sound = sounds["laugh3-5.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 6 then
 local sound = sounds["laugh3-6.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 7 then
 local sound = sounds["laugh3-7.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
end

else
 if worm:player():data().counter == 1 then
 worm:shoot(flameobj, 2, 0.5, 0.2, 0, 0, 5, 0, 6)
  if worm:player():data().flamesound == 3 then
   local sound = sounds["flame.ogg"]
   local x,y = worm:pos()
   sound:play(x, y, 35, 1, 0.4)
   worm:player():data().flamesound = 0
  else worm:player():data().flamesound = worm:player():data().flamesound + 1
  end
 end

end
end

function weapons.madsend(player)
  local w = new_bitstream()
  madsend:send(player, w, 0, SendMode.ReliableOrdered, RepRule.Auth2All )
  player:data().ismad = 1
end


function bindings.playerUpdate(player)

random = randomint(1, 25)
if random == 1 then
 if player:data().counter == 0 then
 player:data().counter = 1
 else random = randomint(1, 3)
  if random == 1 then player:data().counter = 0
  end
 end
end

if player:data().madcount > 0 and player:data().ismad == 0 then
player:data().madcount = player:data().madcount - 0.05
end
if player:data().madcount >= 100 then
  if AUTH and player:data().ismad == 0 and player:is_local() then
   weapons.madsend(player)
  elseif player:data().ismad == 0 and player:is_local() then
  local q = new_bitstream()
  madmsg:send(player, q, 0, SendMode.ReliableOrdered, RepRule.Owner2Auth )
  end
end
if player:data().ismad == 1 then
player:data().madcount = 100
player:data().laughcount = player:data().laughcount + 1
player:worm():damage( 0.04, player )
local worm = player:worm()
weapons.hit(worm, worm)
end
if player:data().laughcount == 190 then
random = randomint(1, 13)
local x,y = player:worm():pos()
 if random == 1 then
 local sound = sounds["laugh3-1.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 2 then
 local sound = sounds["laugh3-2.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 3 then
 local sound = sounds["laugh3-3.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 4 then
 local sound = sounds["laugh3-4.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 5 then
 local sound = sounds["laugh3-5.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 6 then
 local sound = sounds["laugh3-6.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 7 then
 local sound = sounds["laugh3-7.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 8 then
 local sound = sounds["laugh3-8.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
  if random == 9 then
 local sound = sounds["laugh2-1.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 10 then
 local sound = sounds["laugh2-3.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 11 then
 local sound = sounds["laugh2-4.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 12 then
 local sound = sounds["laugh2-5.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
 if random == 13 then
 local sound = sounds["laugh2-6.ogg"]
 sound:play(x, y, 100, 1, 0)
 end
player:data().laughcount = 0
end
end

---LAUGH---

function weapons.hit(object, worm)
local name = worm:player():name()
if worm:health() <= 0 and worm:player() == object:player() and worm:player():data().dead == 0 and AUTH then
  worm:player():data().suicides = worm:player():data().suicides + 1
  worm:player():data().suicidecommited = 1
  worm:player():data().msgcounter = 0
  worm:player():data().msgcounter2 = 0
  local bit = new_bitstream()
  suicidemsg:send(worm:player(), bit, 0, SendMode.ReliableOrdered, RepRule.Auth2All )
  worm:player():data().dead = 1
 elseif worm:health() <= 0 and worm:player():data().dead == 0 and AUTH then
  worm:player():data().msgcounter = 0
  worm:player():data().msgcounter2 = 0
  object:player():data().fragged = 1
  object:player():data().killcount = object:player():data().killcount + 1
  object:player():data().whofragged = name
  local b = new_bitstream()
  b:add_string(worm:player():name())
  fragmsg:send(object:player(), b, 0, SendMode.ReliableOrdered, RepRule.Auth2All )

  local a = new_bitstream()
  fragmsg2:send(object:player(), a, 0, SendMode.ReliableOrdered, RepRule.Auth2All )
  worm:player():data().dead = 1
end
end

end